@echo off
::
:: Copyright (C) 2009  The PARI group.
::
:: This file is part of the PARI/GP package.
::
:: PARI/GP is free software; you can redistribute it and/or modify it under the
:: terms of the GNU General Public License as published by the Free Software
:: Foundation. It is distributed in the hope that it will be useful, but WITHOUT
:: ANY WARRANTY WHATSOEVER.
::
:: Check the License for details. You should have received a copy of it, along
:: with the package; see the file 'COPYING'. If not, write to the Free Software
:: Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
::
if "%1" == "help" (
	echo Usage:
	echo make clean
	echo make check
	echo make help
	echo make 
	echo make --with-gmp GMPINC directory_where_gmp.h_is GMPLIB full_path_to_mpir.lib
	goto :EOF
)
if "%1" == "check" goto :check
if "%1" == "clean" goto :clean
set GMPINC=
set GMPLIB=
set KDIR=none
:loop
if "%1" == "" goto :loopend
if "%1" == "GMPINC" (
	set GMPINC=-I%2
	shift
	shift
	goto :loop
)
if "%1" == "GMPLIB" (
	set GMPLIB=%2
	shift
	shift
	goto :loop
)
if "%1" == "--with-gmp" ( set KDIR=gmp)
shift
goto :loop
:loopend
echo %GMPINC%
echo %GMPLIB%
copy parilvl0.C.h parilvl0.h
if "%KDIR%" == "gmp" (
	copy parilvl0.32.h parilvl0.h
)
set KDIRN=..\src\kernel\none\
set KDIRP=..\src\kernel\%KDIR%\
set D=.\
if not exist tune.h set D=%KDIRP%
copy /B %D%tune.h + %KDIRP%int.h + %KDIRN%level1.h parilvl1.h
copy /B parilvl0.h + parilvl1.h mpinl.h
copy gp_init.h ..\src\gp\gp_init.h
copy highlvl.h ..\src\gp\highlvl.h
copy whatnow.h ..\src\gp\whatnow.h
copy /B %KDIRP%mp.c + %KDIRN%cmp.c + %KDIRN%gcdll.c + %KDIRN%ratlift.c + %KDIRN%invmod.c + %KDIRP%gcd.c + %KDIRN%mp_indep.c + %KDIRN%add.c mp.c
copy init.h ..\src\language\init.h
copy parse.h ..\src\language\parse.h
copy parse.c ..\src\language\parse.c

call "%VS90COMNTOOLS%\..\..\VC\vcvarsall.bat" x86
cl 
if errorlevel 1 (
	echo Cant find the VC command line compiler CL.EXE
	goto :EOF
)
for %%X in ( ..\src\basemath\*.c ..\src\language\*.c ..\src\modules\*.c ..\src\graph\plotnull.c ..\src\gp\*.c ..\src\kernel\none\mpinl.c ..\src\graph\plotport.c ) do (
	cl  /O2 /Ox /Oi /Ot /Oy /nologo /wd4142 /wd4098 /c /GL %%X -I . -I ..\src\headers
	if errorlevel 1 goto :EOF
	)
::   language\eval.c when compiled with full optimization breaks the ffisom test program
cl /nologo /wd4142 /wd4098 /c /GL ..\src\language\eval.c -I . -I ..\src\headers
if errorlevel 1 goto :EOF
cl  /O2 /Ox /Oi /Ot /Oy /nologo /wd4142 /c /GL mp.c -I . -I ..\src\headers %GMPINC%
:: why do we delete this ? 
del gp_rl.obj
link /LTCG *.obj /out:gp.exe %GMPLIB%
goto :EOF

:check
chdir ..\src\test\in
for %%X in ( * ) do (
	if not "%%X" == "pari.ps" (
	echo testing %%X
	type %%X | ..\..\..\Omsvc\gp.exe -q --test 2>&1 | find /v "Total time spent: " > ..\..\..\Omsvc\%%X.txt
	type ..\32\%%X | find /v "Total time spent: " > ..\..\..\Omsvc\expected.txt
	fc /L ..\..\..\Omsvc\%%X.txt ..\..\..\Omsvc\expected.txt  > ..\..\..\Omsvc\diff.txt
	if errorlevel 1 ( echo ERROR for %%X see Omsvc\%%X.txt ) 
	del ..\..\..\Omsvc\expected.txt
)
)
cd ..\..\..\Omsvc
goto :EOF

:clean
del gp.exe mp.c mpinl.h parilvl0.h parilvl1.h 
del *.obj *.txt
:EOF
